# do not import all endpoints into this module because that uses a lot of memory and stack frames
# if you need the ability to import all endpoints from this module, import them with
# from albert.api.apis.path_to_api import path_to_api

import enum


class PathValues(str, enum.Enum):
    API_V3_PREDICTIONS_HEALTH = "/api/v3/predictions/health"
    API_V3_PREDICTIONS = "/api/v3/predictions"
    API_V3_PREDICTIONS_PARENT_ID = "/api/v3/predictions/{parentId}"
    API_V3_PREDICTIONS_MERGEDAT = "/api/v3/predictions/mergedat"
    API_V3_PREDICTIONS_MERGEDAC = "/api/v3/predictions/mergedac"
    API_V3_PREDICTIONS_MODELS_ID = "/api/v3/predictions/models/{id}"
    API_V3_PREDICTIONS_MODELS_PARENT_ID_VERSION_ID = "/api/v3/predictions/models/{parentId}/version/{id}"
    API_V3_PREDICTIONS_MODELS_PARENT_ID_VERSION = "/api/v3/predictions/models/{parentId}/version"
    API_V3_PREDICTIONS_MODELS = "/api/v3/predictions/models"
    API_V3_PREDICTIONS_TASKS = "/api/v3/predictions/tasks"
    API_V3_LOCATIONS_HEALTH = "/api/v3/locations/health"
    API_V3_LOCATIONS = "/api/v3/locations"
    API_V3_LOCATIONS_ID = "/api/v3/locations/{id}"
    API_V3_LOCATIONS_ASYNC_ID = "/api/v3/locations/async/{id}"
    API_V3_PRODUCTDESIGN_HEALTH = "/api/v3/productdesign/health"
    API_V3_PRODUCTDESIGN = "/api/v3/productdesign"
    API_V3_PRODUCTDESIGN_SEARCH = "/api/v3/productdesign/search"
    API_V3_PRODUCTDESIGN_SUGGEST = "/api/v3/productdesign/suggest"
    API_V3_PRODUCTDESIGN_ID = "/api/v3/productdesign/{id}"
    API_V3_PRODUCTDESIGN_ID_DESIGNS = "/api/v3/productdesign/{id}/designs"
    API_V3_PRODUCTDESIGN_ID_PRODUCTS = "/api/v3/productdesign/{id}/products"
    API_V3_PRODUCTDESIGN_ID_VALUES = "/api/v3/productdesign/{id}/values"
    API_V3_PRODUCTDESIGN_ID_GRID = "/api/v3/productdesign/{id}/grid"
    API_V3_PRODUCTDESIGN_ID_UNPACK = "/api/v3/productdesign/{id}/unpack"
    API_V3_PRODUCTDESIGN_INVENTORIES_ID = "/api/v3/productdesign/inventories/{id}"
    API_V3_PRODUCTDESIGN_MERGEINVENTORY = "/api/v3/productdesign/mergeinventory"
    API_V3_INVENTORIES_HEALTH = "/api/v3/inventories/health"
    API_V3_INVENTORIES = "/api/v3/inventories"
    API_V3_INVENTORIES_ID = "/api/v3/inventories/{id}"
    API_V3_REPORTS_HEALTH = "/api/v3/reports/health"
    API_V3_REPORTS_SEARCH = "/api/v3/reports/search"
    API_V3_REPORTS_SUGGEST = "/api/v3/reports/suggest"
    API_V3_REPORTS_INVENTORY_EQUIPMENT_USAGE = "/api/v3/reports/inventoryEquipmentUsage"
    API_V3_REPORTS_INVENTORY_MOVEMENTS = "/api/v3/reports/inventoryMovements"
    API_V3_REPORTS_TYPE = "/api/v3/reports/type"
    API_V3_REPORTS_ANALYTICS_ID = "/api/v3/reports/analytics/{id}"
    API_V3_REPORTS_DATASCIENCE_ID = "/api/v3/reports/datascience/{id}"
    API_V3_REPORTS_TYPE_ID = "/api/v3/reports/type/{id}"
    API_V3_REPORTS = "/api/v3/reports"
    API_V3_REPORTS_COPY = "/api/v3/reports/copy"
    API_V3_REPORTS_ID = "/api/v3/reports/{id}"
